# Baidu Maps for Flutter

集成百度地图的地图定位以及地图展示，支持Android、ios

## Getting Started

1、到百度地图开放平台http://lbsyun.baidu.com/获取应用key，ios，Android需要单独建立应用

### 初始化

**Android**

在android/app/build.gradle文件中增加下面一段内容

```
android {
    ...

    defaultConfig {
        ...
        manifestPlaceholders = [
                BAIDU_MAP_KEY : "百度地图AK", /// 百度地图AK
        ]
    }
    ...
}
```

**IOS**

1、直接在dart文件main.dart中直接设置AK

```
import 'package:rc_bd_map/rc_bd_map.dart';
...
void main(){     
     RcBdMap.setAK("你的AK");
     runApp(new MyApp());
   }
```

2、通过xcode打开ios端代码，在info.plist或者选中Runner->TARGETS->info增加下面内容

1）由于使用UiKitView，添加Key为io.flutter.embedded_views_preview，type为Boolean，Value为YES

2）添加定位相关的内容

具体添加内容为下：

| Key                                                         | Type    | Value                              |
| :---------------------------------------------------------- | ------- | ---------------------------------- |
| io.flutter.embedded_views_preview                           | Boolean | YES                                |
| Privacy - Location Always Usage Description                 | String  | 您的位置信息将用于获取城市相关数据 |
| Privacy - Location Always and When In Use Usage Description | String  | 是否允许定位                       |
| Privacy - Location When In Use Usage Description            | String  | 您的位置信息将用于获取城市相关数据 |

### 使用

```
dependencies:
  flutter_baidu_map: ^0.0.1
```

#### 1、获取定位

```
BaiduLocation location = await FlutterBaiduMap.getCurrentLocation();
```

#### 2、加载地图

```
Container(
                height: 300,
                //name：坐标点名称
                child: RcBdMap.getMap(latitude, longitude, name),
//              child: Center(child: Text("地图"),),
              ),
```

<!--需要widget接收地图，并设置高度，不然会导致高度溢出-->

3、地图检索

```
//keyword：搜索关键词
RcBdMap.checkMapType(latitude, longitude, keyword);
```

<!--检索前需要加载地图，并传入经纬度已经检索类型，目前支持中学、体育馆、健身房、公交、公园、咖啡馆、商场、地铁、大学、小学、幼儿园、电影院、药店、菜市场、超市、银行、餐厅搜索，ios端需要将代码中的Map Icons拷贝到Assets.xcassets中，名字不需要进行改变-->

### 感谢

[flutter_baidu_map]: https://pub.dev/packages/flutter_baidu_map
[百度地图开放平台]: http://lbsyun.baidu.com/


