package cn.rc100.rc_bd_map.bd_map_view;

import android.content.Intent;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.shim.ShimPluginRegistry;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry;

public class RcBdMapViewPlugin implements FlutterPlugin,MethodChannel.MethodCallHandler, PluginRegistry.ActivityResultListener {

    public static void registerWith(PluginRegistry registry) {
        final String key = RcBdMapViewPlugin.class.getCanonicalName();

        if (registry.hasPlugin(key)) return;

        //注册platformView
        PluginRegistry.Registrar registrar = registry.registrarFor(key);
        registrar.platformViewRegistry().registerViewFactory("BaiduMapView", new RcBdMapVewFactory(registrar));

        //传入Activity
        final RcBdMapViewPlugin plugin = new RcBdMapViewPlugin();
        // 注册ActivityResult回调
        registrar.addActivityResultListener(plugin);
    }

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
//        final MethodChannel channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "BaiduMapView");
//        channel.setMethodCallHandler(new RcBdMapPlugin());


        ShimPluginRegistry shimPluginRegistry = new ShimPluginRegistry(flutterPluginBinding.getFlutterEngine());

        final String key = RcBdMapViewPlugin.class.getCanonicalName();

        if (shimPluginRegistry.hasPlugin(key)) return;

        //注册platformView
        PluginRegistry.Registrar registrar = shimPluginRegistry.registrarFor(key);
        if(registrar.activity()==null){
            System.out.println("=============================+> 初始化activity为空");
            return;
        }

        registrar.platformViewRegistry().registerViewFactory("BaiduMapView", new RcBdMapVewFactory(registrar));

        //传入Activity
        final RcBdMapViewPlugin plugin = new RcBdMapViewPlugin();
        // 注册ActivityResult回调
        registrar.addActivityResultListener(plugin);


    }

    @Override
    public boolean onActivityResult(int i, int i1, Intent intent) {
        return false;
    }

    @Override
    public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {


    }

    @Override
    public void onDetachedFromEngine(FlutterPluginBinding binding) {

    }
}
