//
//  BaiduMapLocationPlugin.m
//  rc_bd_map
//
//  Created by 荣城 on 2020/1/18.
//

#import "BaiduMapLocationPlugin.h"

@implementation BaiduMapLocationPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"rc_bd_map_location"
            binaryMessenger:[registrar messenger]];
  BaiduMapLocationPlugin* instance = [[BaiduMapLocationPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"initLocationByKey" isEqualToString:call.method]) {
      BMKMapManager *_mapManager = [[BMKMapManager alloc] init];
      // 如果要关注网络及授权验证事件，请设定generalDelegate参数
      BOOL ret = [_mapManager start:call.arguments  generalDelegate:nil];
      if (!ret) {
          NSLog(@"manager start failed!");
      }
      //设置全局的坐标系
      [BMKMapManager setCoordinateTypeUsedInBaiduMapSDK:BMK_COORDTYPE_BD09LL];
      [[BMKLocationAuth sharedInstance] checkPermisionWithKey:call.arguments authDelegate:self];
      result(@YES);
  } else if([@"getCurrentLocation" isEqualToString:call.method]) {
    //初始化定位功能
    BMKLocationManager *_locationManager = [[BMKLocationManager alloc]init];
    _locationManager.delegate = self;
    _locationManager.coordinateType = BMKLocationCoordinateTypeBMK09LL;
    _locationManager.distanceFilter = kCLDistanceFilterNone;
    _locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    _locationManager.activityType = CLActivityTypeOtherNavigation;
    _locationManager.pausesLocationUpdatesAutomatically = NO;
    _locationManager.locationTimeout = 10;
    _locationManager.reGeocodeTimeout = 10;
    NSMutableDictionary *mapLocationData = [NSMutableDictionary dictionaryWithCapacity:6];
    [_locationManager requestLocationWithReGeocode:YES withNetworkState:YES completionBlock:^(BMKLocation * _Nullable location, BMKLocationNetworkState state, NSError * _Nullable error) {
            NSLog(@"定位成功");
           
            if (error)
             {
                 NSLog(@"locError:{%ld - %@};", (long)error.code, error.localizedDescription);
             }
            if (location) {//得到定位信息，添加annotation
                 if (location.location) {
//                     NSLog(@"LOC = %@",location.location);
                     //强转经纬度
                     [mapLocationData setObject:[NSString stringWithFormat:@"%f",location.location.coordinate.latitude] forKey:@"latitude"];
                     [mapLocationData setObject:[NSString stringWithFormat:@"%f",location.location.coordinate.longitude] forKey:@"longitude"];
                     NSLog(@"%@", [NSString stringWithFormat:@"%f %f",location.location.coordinate.longitude,location.location.coordinate.latitude]);
                 }
                 if (location.rgcData) {
                     NSLog(@"rgc = %@",[location.rgcData description]);
                     [mapLocationData setObject:[location.rgcData description] forKey:@"address"];
                     [mapLocationData setObject:location.rgcData.city forKey:@"city"];
                     if(location.rgcData.adCode!=nil){
                         [mapLocationData setObject:location.rgcData.adCode forKey:@"adCode"];
                     }
                     if(location.rgcData.cityCode!=nil){
                         [mapLocationData setObject:location.rgcData.cityCode forKey:@"cityCode"];
                     }
                 }
                 if (location.rgcData.poiList) {
                     for (BMKLocationPoi * poi in location.rgcData.poiList) {
                         NSLog(@"poi = %@, %@, %f, %@, %@", poi.name, poi.addr, poi.relaiability, poi.tags, poi.uid);
                     }
                 }
                 if (location.rgcData.poiRegion) {
                     NSLog(@"poiregion = %@, %@, %@", location.rgcData.poiRegion.name, location.rgcData.poiRegion.tags, location.rgcData.poiRegion.directionDesc);
                 }
             }
            NSLog(@"%@", mapLocationData);
//            NSError *error = nil;
            error = nil;
            NSData *jsonData = nil;
            jsonData = [NSJSONSerialization dataWithJSONObject:mapLocationData options:NSJSONWritingPrettyPrinted error:&error];
            NSString *jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
            result(jsonString);
    }];
  }else{
      result(FlutterMethodNotImplemented);
  }
}

@end

